package nc.impl.hr.train;

import java.io.FileInputStream;
import java.io.IOException;
import java.net.URL;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.Properties;
import java.util.concurrent.TimeUnit;

import org.apache.commons.codec.digest.DigestUtils;

import com.alibaba.fastjson.JSONObject;

import nc.vo.pub.BusinessException;
import okhttp3.Headers;
import okhttp3.MediaType;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.RequestBody;
import okhttp3.Response;

public class TrainCloudSchoolImpl {
	
	private static Properties props = new Properties(); 
	
	static {
		try {
			if (props.size() <= 0) {
				ClassLoader classLoader = new Object() {}.getClass().getClassLoader();
				URL url = classLoader.getResource("cloudapi.properties");
				FileInputStream in = new FileInputStream(url.getFile());
				props.load(in);
			}
		} catch (IOException e) {
			
		}
	}
	
	public String getUrl() {
		return props.getProperty("cloudapi.url");
	}
	
	/**
	 * ȡͷ
	 * @return
	 */
	public Map<String,Object> getBodyMap() {
        Map<String, Object> body = new HashMap();
        String apikey = props.getProperty("cloudapi.apikey");//"21d0b041-13d4-4670-a107-626443693182";// ѧÿͷȡ
        String salt = String.valueOf(new Date().getTime()).substring(0, 6);;// Ϊapiÿɵַ3λ32λ
        String secretKey =  props.getProperty("cloudapi.secretKey");//"552333e8-36b7-4eb1-a131-4aa63004e92b";//ѧÿͷȡ
        String signature = DigestUtils.sha256Hex(secretKey + salt);//secretKey salt 2ַȺ˳ƴӳһַSHA-256ϣ
        body.put("apikey", apikey);
        body.put("salt", salt);
        body.put("signature", signature);
        return body;
    }
	
	/**
	 * ݴòһѧýӿ
	 * @param bodyMap
	 * @param url
	 * @return
	 */
	public String getCouldSchool(Map<String,Object> bodyMap,String url) throws BusinessException{
		String result = "";
		String bodyString = JSONObject.toJSONString(bodyMap);
        try {
            OkHttpClient client = new OkHttpClient().newBuilder().readTimeout(500000, TimeUnit.MILLISECONDS).build();
            MediaType mediaType = MediaType.parse("application/json; charset=utf-8");
            RequestBody requestBody = RequestBody.create(mediaType, bodyString);
            Request request = new Request.Builder().headers(Headers.of(new HashMap<>(1))).url(url).post(requestBody).build();
            Response response = client.newBuilder().readTimeout(500000L, TimeUnit.MILLISECONDS).build().newCall(request).execute();
            result = response.body().string();
        } catch (Exception e) {
            System.out.println("ִаͷpost,body:" + bodyMap + ",url:" + url + ":" + bodyMap + ",ִдϢ:" + e);
            throw new BusinessException("ִаͷpost,body:" + bodyMap + ",url:" + url + ":" + bodyMap + ",ִдϢ:" + e);
        }
        return result;
	}
	
	/**
	 * ȡûб
	 * @param bodyMap
	 * @return
	 */
	public String getUserList(Map<String,Object> bodyMap) throws BusinessException{
		String result = "";
		bodyMap.put("pageNo", 1);
//		bodyMap.put("updateDate", new UFDate().toDate());//˴ӽӿ贫
		String bodyString = JSONObject.toJSONString(bodyMap);
		String qurl = getUrl();
        // ﻷhttp://sdcs-api-dpbc1.yunxuetang.cn/v1 ;
        // ucloud http://sdcs-api-dpb.yunxuetang.cn/v1 ;
		//http://sdcs-api-dpb.yunxuetang.com.cn
        String url = qurl + "/v1/customdata/users";
        try {
        	result = getCouldSchool(bodyMap,url);
        } catch (Exception e) {
            System.out.println("ִаͷpost,body:" + bodyMap + ",url:" + url + ":" + bodyMap + ",ִдϢ:" + e);
            throw new BusinessException("ִаͷpost,body:" + bodyMap + ",url:" + url + ":" + bodyMap + ",ִдϢ:" + e);
        }
        return result;
	}
	
	/**
	 * ѧϰƻִϸҳѧϰƻ
	 * @param bodyMap
	 * @param curPage ǰҳ
	 * @param pageSize ÿҳС
	 * @return
	 * @throws BusinessException 
	 */
	public String getStudyplandetailpagelist(Map<String,Object> bodyMap,int curPage,int pageSize) throws BusinessException {
		String result = "";
		bodyMap.put("curPage", curPage);//ǰҳ
		bodyMap.put("pageSize", pageSize);//ÿҳС
//		bodyMap.put("updateDate", new UFDate().toDate());//Աѧϰ֪ʶ(ڻȡݣԱѧϰʱڵڸڵ)ʾ2017-10-01
//		bodyMap.put("updateEndDate", new UFDate().toDate());//½ʱ䣬ѯӸ¿ʼڵ½֮й»
//		bodyMap.put("planID", "");//ѧϰƻid Ǳ
//		bodyMap.put("userId", "");//ûid
//		bodyMap.put("status", "");//״̬ö٣δѧϰNoStartѧϰStudying Completed Ǳ
		String bodyString = JSONObject.toJSONString(bodyMap);
		String qurl = getUrl();
		String url = qurl + "/v1/studyplans/studyplandetailpagelist";
        try {
        	result = getCouldSchool(bodyMap,url);
        } catch (Exception e) {
            System.out.println("ִаͷpost,body:" + bodyMap + ",url:" + url + ":" + bodyMap + ",ִдϢ:" + e);
            throw new BusinessException("ִаͷpost,body:" + bodyMap + ",url:" + url + ":" + bodyMap + ",ִдϢ:" + e);
        }
        return result;
	}
	
	/**
	 * ѵγ̣ҳ
	 * @param bodyMap
	 * @param curPage
	 * @param pageSize
	 * @return
	 * @throws BusinessException 
	 */
	public String gettrainingcontentlistpage(Map<String,Object> bodyMap,int curPage,int pageSize) throws BusinessException {
		String result = "";
		bodyMap.put("curPage", curPage);//ǰҳ
		bodyMap.put("pageSize", pageSize);//ÿҳС
//		bodyMap.put("updateDate", new UFDate().toDate());//ѵγ̸ 2020-01-01
//		bodyMap.put("trainingID", "");//ѵID Ǳ
		String bodyString = JSONObject.toJSONString(bodyMap);
		String qurl = getUrl();
		String url = qurl + "/v1/training/gettrainingcontentlistpage";
        try {
        	result = getCouldSchool(bodyMap,url);
        } catch (Exception e) {
            System.out.println("ִаͷpost,body:" + bodyMap + ",url:" + url + ":" + bodyMap + ",ִдϢ:" + e);
            throw new BusinessException("ִаͷpost,body:" + bodyMap + ",url:" + url + ":" + bodyMap + ",ִдϢ:" + e);
        }
        return result;
	}
	
	/**
	 * ѵγ(ѵ)
	 * @param bodyMap
	 * @param curPage
	 * @param pageSize
	 * @param trainContentID
	 * @return
	 * @throws BusinessException 
	 */
	public String getcontentfinshdetaillist(Map<String,Object> bodyMap,int curPage,int pageSize,String trainContentID) throws BusinessException {
		String result = "";
		bodyMap.put("curPage", curPage);//ǰҳ
		bodyMap.put("pageSize", pageSize);//ÿҳС
//		bodyMap.put("updateDate", new UFDate().toDate());//ѵγ̸ 2020-01-01
		bodyMap.put("trainContentID", trainContentID);//ѵid 
		String qurl = getUrl();
		String url = qurl + "/v1/training/getcontentfinshdetaillist";
        try {
        	result = getCouldSchool(bodyMap,url);
        } catch (Exception e) {
            System.out.println("ִаͷpost,body:" + bodyMap + ",url:" + url + ":" + bodyMap + ",ִдϢ:" + e);
            throw new BusinessException("ִаͷpost,body:" + bodyMap + ",url:" + url + ":" + bodyMap + ",ִдϢ:" + e);
        }
        return result;
	}
	
	/**
	 * ȡ֪ʶĿ¼б
	 * @param bodyMap
	 * @param curPage
	 * @param pageSize
	 * @return
	 * @throws BusinessException 
	 */
	public String getKngcatalogs(Map<String,Object> bodyMap,int curPage,int pageSize) throws BusinessException {
		String result = "";
//		bodyMap.put("curPage", curPage);//ǰҳ
//		bodyMap.put("pageSize", pageSize);//ÿҳС
//		bodyMap.put("updateDate", new UFDate().toDate());//ѵγ̸ 2020-01-01
//		bodyMap.put("trainContentID", trainContentID);//ѵid 
		String qurl = getUrl();
		String url = qurl + "/v1/customdata/knowledges/kngcatalogs";
        try {
        	result = getCouldSchool(bodyMap,url);
        } catch (Exception e) {
            System.out.println("ִаͷpost,body:" + bodyMap + ",url:" + url + ":" + bodyMap + ",ִдϢ:" + e);
            throw new BusinessException("ִаͷpost,body:" + bodyMap + ",url:" + url + ":" + bodyMap + ",ִдϢ:" + e);
        }
        return result;
	}
	
	/**
	 * ȡ֪ʶб
	 * @param bodyMap
	 * @param curPage
	 * @param pageSize
	 * @return
	 * @throws BusinessException 
	 */
	public String getKnowledges(Map<String,Object> bodyMap,int curPage,int pageSize) throws BusinessException {
		String result = "";
		String qurl = getUrl();
		String url = qurl + "/v1/customdata/knowledges";
        try {
        	result = getCouldSchool(bodyMap,url);
        } catch (Exception e) {
            System.out.println("ִаͷpost,body:" + bodyMap + ",url:" + url + ":" + bodyMap + ",ִдϢ:" + e);
            throw new BusinessException("ִаͷpost,body:" + bodyMap + ",url:" + url + ":" + bodyMap + ",ִдϢ:" + e);
        }
        return result;
	}

	/**
	 * Աѧϰ¼  ûѧϰ¼ѧϰѧϰƻλѧϰʽѧϰȣγ̰ϸ
	 * @param bodyMap
	 * @param curPage
	 * @param pageSize
	 * @return
	 * @throws BusinessException 
	 */
	public String getOnlineuserknowledge(Map<String,Object> bodyMap,int curPage,int pageSize) throws BusinessException {
		String result = "";
		bodyMap.put("curPage", curPage);//ǰҳ
		bodyMap.put("pageSize", pageSize);//ÿҳС
//		updateDate ¿ʼʱ
//		updateEndDate ½ʱ ʱһ£󣬽ðѯ
		String bodyString = JSONObject.toJSONString(bodyMap);
		
		String qurl = getUrl();
		String url = qurl + "/v1/knowledge/getonlineuserknowledge";
        try {
        	result = getCouldSchool(bodyMap,url);
        } catch (Exception e) {
            System.out.println("ִаͷpost,body:" + bodyMap + ",url:" + url + ":" + bodyMap + ",ִдϢ:" + e);
            throw new BusinessException("ִаͷpost,body:" + bodyMap + ",url:" + url + ":" + bodyMap + ",ִдϢ:" + e);
        }
        return result;
	}
	
}
